module.exports = function(API){
	const {Language, Errors: {ErrorCodes}} = API;
	Object.setPrototypeOf(this, Language.prototype);
	Language.call(this, "PT", {
		name: "Português",
		version: "0.1",
		author: "abc & Juze",
		description: "Default Portuguese translation"
	});
	this.api = {
		errors: {
			[ErrorCodes.﻿Empty]: "",
			[ErrorCodes.ConnectionClosed]: 'Conexão fechada$1?(" $1":"")',
			[ErrorCodes.GameStateTimeout]: "Tempo limite do estado do jogo",
			[ErrorCodes.RoomClosed]: "A sala estava fechada.",
			[ErrorCodes.RoomFull]: "O quarto está cheio.",
			[ErrorCodes.WrongPassword]: "Senha errada.",
			[ErrorCodes.BannedBefore]: "Você está banido desta sala.",
			[ErrorCodes.IncompatibleVersion]: "Versão incompatível do jogo.",
			[ErrorCodes.FailedHost]: "Falha ao se conectar ao host da sala. Se esse problema persistir, consulte o guia de solução de problemas: https://github.com/haxball/haxball-issues/wiki/Connection-Issues",
			[ErrorCodes.Unknown]: "Ocorreu um erro ao tentar entrar na sala.<br><br>Isso pode ser causado por uma extensão do navegador, tente desativar todas as extensões e atualizar o site.<br><br>O erro foi impresso no console do inspetor.",
			[ErrorCodes.Cancelled]: "Cancelado",
			[ErrorCodes.FailedPeer]: "Falhou ao se conectar ao par.",
			[ErrorCodes.KickedNow]: 'Você tinha $2?(" Banido":"chutado")$3?(" Por $3":"")$1?(" ($1)":"")',
			[ErrorCodes.Failed]: "Falha",
			[ErrorCodes.MasterConnectionError]: "Erro de conexão mestre",
			[ErrorCodes.StadiumParseError]: 'Erro no índice "$1": $2',
			[ErrorCodes.StadiumParseSyntaxError]: "SyntaxError na linha: $1",
			[ErrorCodes.StadiumParseUnknownError]: "Erro ao carregar o arquivo do estádio.",
			[ErrorCodes.ObjectCastError]: "Não é possível lançar $1 para $2",
			[ErrorCodes.TeamColorsReadError]: "Muitos",
			[ErrorCodes.UTF8CharacterDecodeError]: "Não é possível decodificar o caractere UTF8 no deslocamento $1: charCode ($2) é inválido",
			[ErrorCodes.ReadTooMuchError]: "Leia demais",
			[ErrorCodes.ReadWrongStringLengthError]: "O comprimento real da string difere da especificaçãoFied: $1 bytes",
			[ErrorCodes.EncodeUTF8CharNegativeError]: "Não é possível codificar o caractere UTF8: charCode ($1) é negativo",
			[ErrorCodes.EncodeUTF8CharTooLargeError]: "Não é possível codificar o caractere UTF8: charCode ($1) é muito grande (>= 0x80000000)",
			[ErrorCodes.CalculateLengthOfUTF8CharNegativeError]: "Não é possível calcularUlate length of UTF8 character: charCode ($1) is negative",
			[ErrorCodes.CalculateLengthOfUTF8CharTooLargeError]: "Não é possível calcular o comprimento do caractere UTF8: charCode ($1) é muito grande (>= 0x80000000)",
			[ErrorCodes.BufferResizeParameterTooSmallError]: "Não é possível redimensionar o buffer para uma capacidadeInferior a 1",
			[ErrorCodes.BadColorError]: "Bad color",
			[ErrorCodes.BadTeamError]: "Bad team value",
			[ErrorCodes.StadiumLimitsExceededError]: "Error",
			[ErrorCodes.MissingActionConfigError]: "Class doesn't have a config",
			[ErrorCodes.UnregisteredActionError]: "Tied to pack unregistered action",
			[ErrorCodes.MissingImplementationError]: "Missingimplementation",
			[ErrorCodes.AnnouncementActionMessageTooLongError]: "Message too long",
			[ErrorCodes.ChatActionMessageTooLongError]: "Message too long",
			[ErrorCodes.KickBanReasonTooLongError]: "String too long",
			[ErrorCodes.ChangeTeamColorsInvalidTeamIdError]: "Invalid team id",
			[ErrorCodes.MissingRecaptchaCallbackError]: "Recaptcha requested. Defina um token de trabalho ao criar/se juntar a uma sala." ,
			[ErrorCodes.ReplayFileVersionMismatchError]: "Os dados de repetição são de uma versão diferente",
			[ErrorCodes.ReplayFileReadError]: "Não foi possível carregar dados de reprodução.",
			[ErrorCodes.JoinRoomNullIdAuthError]: "Id e authObj não podem ser nulos.(Dentro do 1o parâmetro)",
			[ErrorCodes.PlayerNameTooLongError]: "Name too long",
			[ErrorCodes.PlayerCountryTooLongError]: "Country too long",
			[ErrorCodes.PlayerAvatarTooLongError]: "Avatar too long",
			[ErrorCodes.PlayerJoinBlockedByMPDError]: "Player join not allowed: $3 $4 $5 $1 $2",
			[ErrorCodes.PlayerJoinBlockedByORError]: "PlayerParticipar do evento bloqueado por OperationReceived: $1",
			[ErrorCodes.PluginNotFoundError]: "Plugin não encontrado no índice $1",
			[ErrorCodes.PluginNameChangeNotAllowedError]: "O nome do plugin não deve mudar",
			[ErrorCodes.LibraryNotFoundError]: "Biblioteca não encontrada no índice $1",
			[ErrorCodes.LibraryNameChangeNotAllowedError]: "LibraryNome não deve mudar",
			[ErrorCodes.AuthFromKeyInvalidIdFormatError]: "Invalid id format",
			[ErrorCodes.BadActorError]: "Bad Actor",
			[ErrorCodes.AuthBannedError]: "Auth banned: $1",
			[ErrorCodes.NoProxyIdentityProblem]: "O backend do basro não é compatível com o sistema de início de sessão, pelo que o token de identidade e os eventos de identidade estão desactivados.",
			[ErrorCodes.NoProxyIdentitySolution]: "Solução: Utilizar um servidor proxy e tratar os dados de início de sessão nesse servidor.",
			[ErrorCodes.FailedToCreateRoom]: "Ocorreu um erro ao tentar criar a sala. ($1)"
		}
	};
};
