module.exports = function(API){
	const {Language, Errors: {ErrorCodes}} = API;
	Object.setPrototypeOf(this, Language.prototype);
	Language.call(this, "ES", {
		name: "Español",
		version: "0.2",
		author: "JerryOldson",
		description: "Traducción del español por defecto"
	});
	this.api = {
		errors: {
			[ErrorCodes.Empty]: "",
			[ErrorCodes.ConnectionClosed]: 'Conexión cerrada$1?(" $1":"")',
			[ErrorCodes.GameStateTimeout]: "Game state timeout",
			[ErrorCodes.RoomClosed]: "La sala ha sido cerrada.",
			[ErrorCodes.RoomFull]: "La sala está llena.",
			[ErrorCodes.WrongPassword]: "Contraseña incorrecta.",
			[ErrorCodes.BannedBefore]: "Estás baneado de esta sala.",
			[ErrorCodes.IncompatibleVersion]: "Version de juego incompatible.",
			[ErrorCodes.FailedHost]: "Falló al querer ingresar a la sala. Si el problema persiste, eche un vistazo a la guía de solución de problemas: https://github.com/haxball/haxball-issues/wiki/Connection-Issues",
			[ErrorCodes.Unknown]: "Ha ocurrido un error al intentar ingresar a la sala.<br><br>Esto puede ser ocasionado por una extensión del navegador, intenta deshabilitando todas las extensiones y reiniciando el sitio.<br><br>El error ha sido loggeado en la consola del navegador.",
			[ErrorCodes.Cancelled]: "Cancelado",
			[ErrorCodes.FailedPeer]: "Fallo al conectar al peer.",
			[ErrorCodes.KickedNow]: 'Fuiste $2?("baneado":"kickeado")$3?(" por $3":"")$1?(" ($1)":"")',
			[ErrorCodes.Failed]: "Falló",
			[ErrorCodes.MasterConnectionError]: "Error de conexión Master",
			[ErrorCodes.StadiumParseError]: 'Error en "$1" index: $2',
			[ErrorCodes.StadiumParseSyntaxError]: "SyntaxError en la línea: $1",
			[ErrorCodes.StadiumParseUnknownError]: "Error al cargar el archivo.",
			[ErrorCodes.ObjectCastError]: "No se puede convertir $1 a $2",
			[ErrorCodes.TeamColorsReadError]: "Too many",
			[ErrorCodes.UTF8CharacterDecodeError]: "No se puede decodificar el carácter UTF8 en el ofsset $1: el charCode es inválido ($2)",
			[ErrorCodes.ReadTooMuchError]: "Read too much",
			[ErrorCodes.ReadWrongStringLengthError]: "La longitud del string difiere de lo especificado: $1 bytes",
			[ErrorCodes.EncodeUTF8CharNegativeError]: "No se puede codificar el carácter UTF8: el charCode es negativo ($1)",
			[ErrorCodes.EncodeUTF8CharTooLargeError]: "No se puede codificar el carácter UTF8: el charCode es muy largo ($1) (>= 0x80000000)",
			[ErrorCodes.CalculateLengthOfUTF8CharNegativeError]: "No se puede calcular la longitud del carácter UTF8: el charCode es negativo ($1)",
			[ErrorCodes.CalculateLengthOfUTF8CharTooLargeError]: "No se puede calcular la longitud del carácter UTF8: el charCode es muy largo ($1) (>= 0x80000000)",
			[ErrorCodes.BufferResizeParameterTooSmallError]: "No se puede cambiar el tamaño del buffer a una capacidad menor a 1",
			[ErrorCodes.BadColorError]: "Color inválido",
			[ErrorCodes.BadTeamError]: "Valor de equipo inválido",
			[ErrorCodes.StadiumLimitsExceededError]: "Error",
			[ErrorCodes.MissingActionConfigError]: "La clase no tiene una configuración",
			[ErrorCodes.UnregisteredActionError]: "Tried to pack unregistered action",
			[ErrorCodes.MissingImplementationError]: "Implementación faltante",
			[ErrorCodes.AnnouncementActionMessageTooLongError]: "Mensaje muy largo",
			[ErrorCodes.ChatActionMessageTooLongError]: "Mensaje muy largo",
			[ErrorCodes.KickBanReasonTooLongError]: "String muy largo",
			[ErrorCodes.ChangeTeamColorsInvalidTeamIdError]: "Id de equipo inválido",
			[ErrorCodes.MissingRecaptchaCallbackError]: "Recaptcha solicitado. Establece un token válido al crear/ingresar a la sala.",
			[ErrorCodes.ReplayFileVersionMismatchError]: "La información de la replay es de una versión diferente",
			[ErrorCodes.ReplayFileReadError]: "No se pudo cargar la información de la replay.",
			[ErrorCodes.JoinRoomNullIdAuthError]: "Id y authObj no pueden ser nulos. (dentro del primer parámetro)",
			[ErrorCodes.PlayerNameTooLongError]: "Nombre muy largo",
			[ErrorCodes.PlayerCountryTooLongError]: "País muy largo",
			[ErrorCodes.PlayerAvatarTooLongError]: "Avatar muy largo",
			[ErrorCodes.PlayerJoinBlockedByMPDError]: "Ingreso de jugador no permitido: $3 $4 $5 $1 $2",
			[ErrorCodes.PlayerJoinBlockedByORError]: "Evento de ingreso de jugador bloqueado por onOperationReceived: $1",
			[ErrorCodes.PluginNotFoundError]: "Plugin no encontrado en el índice $1",
			[ErrorCodes.PluginNameChangeNotAllowedError]: "El nombre del plugin no debería cambiar",
			[ErrorCodes.LibraryNotFoundError]: "Library no encontrado en el índice $1",
			[ErrorCodes.LibraryNameChangeNotAllowedError]: "El nombre de la librería no debería cambiar",
			[ErrorCodes.AuthFromKeyInvalidIdFormatError]: "Formato de ID inválido",
			[ErrorCodes.BadActorError]: "Bad Actor",
			[ErrorCodes.AuthBannedError]: "Auth baneada: $1",
			[ErrorCodes.NoProxyIdentityProblem]: "El backend de basro no es compatible con el sistema de login, por lo que el token de identidad y los eventos de identidad están desactivados.",
			[ErrorCodes.NoProxyIdentitySolution]: "Solución: Utiliza un servidor proxy y gestiona allí los datos de acceso.",
			[ErrorCodes.FailedToCreateRoom]: "Se produjo un error al intentar crear la sala. ($1)"
		}
	};
};
